=== debian/changelog ===
ecl (11.1.1+dfsg1-2) unstable; urgency=low

  * Disable threads on kfreebsd (Closes: #696757). Thanks to Steven
    Chamberlain for the suggestion

 -- Christoph Egger <christoph@debian.org>  Sun, 17 Mar 2013 19:44:26 +0100

ecl (11.1.1+dfsg1-1) unstable; urgency=low
  
     * Remove GFDL documentation (Closes: #695718)
  
 -- Christoph Egger <christoph@debian.org>  Wed, 12 Dec 2012 16:25:48 -0800 
