=== debian/rules ===
--- 
+++ 
@@ -28,10 +28,16 @@
 endif
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
 # gengc doesn't work on ia64 right now -- check again for next version
 ifneq ($(DEB_HOST_ARCH),ia64)
   confflags += --enable-gengc
+endif
+
+# threads seem broken currently except on Linux (see #696757, #648993)
+ifeq ($(DEB_HOST_ARCH_OS),linux)
+  confflags += --enable-threads=yes
 endif
 
 # force to use ginstall-info:
@@ -56,7 +62,6 @@
 	   --with-system-gmp=yes \
 	   --with-tcp \
 	   --with-clx  \
-	   --enable-threads=yes \
 	   --enable-boehm=system  \
 	   --with-x
